          nolist

* einfaches stack-device fr zahlen, anordnung passend fr die ri-vectoren.
* mit den kanalvariablen steht eine vectortabelle zur verfgung, die einige
* routinen hieraus enthlt. weitere 7 langworte sind noch frei nutzbar.
* vorgegeben f.p.-format, kann in buf_fmt frei gewhlt werden, auch ungerade.
* in der hiermit vorliegenden form sind nur gerade werte bis 6 auswertbar.
* zustzlich sind ein paar grundlegende basic-befehle angegeben. auch die
* TK2-befehle PUT und GET arbeiten einwandfrei, strings unpassender lnge
* werden - auch bei PRINT - abgewiesen, INPUT macht fehler.   

          section   STK       

* 9 langwort-kanalvariable fr STAK-Device. 
buf_bas   equ       24                  ; basis des reservierten bereichs
buf_bot   equ       28                  ; untere +6 , obergrenze-6 local
buf_top   equ       32                  ; obere puffergrenze
buf_ptr   equ       36                  ; laufptr nach bytes
buf_fmt   equ       40                  ; .w daten-format bytes je posten
buf_wrd   equ       42                  ; .w frei 
vec_len   equ       44                  ; len_chk   prfung der bergabelnge
vec_chk   equ       48                  ; chk_ptr   ptr in stk-grenzen
vec_ofs   equ       52                  ; ofs_ptr   ptr format justiert & rest
vec_chi   equ       56                  ; chan_in   basic-kanal holen
*         dort ptr.w(pc) auf offset -2  chan_id   prft basic-kanal (d5)
*                                   -4  chan_ck   dto., jedoch id in a0
vec_pmi   equ       60                  ; parm_in   kanal & basic-parm holen
*         dort ptr.w(pc) auf offset -2  parm_vi   mit a0 a4, nur parm holen
*                                   -4  parm_it   d5 vorgabe, holt eine integer
vec_pmo   equ       64                  ; parm_ou  zahl an basic abliefern
*         dort ptr.w(pc) auf offset -2  parm_oi   d5 als integer abliefern
*                                   -4  prm_mem   a4 len bv.chrix-aufruf
nul1      equ       68                  ; frei ...
nul0      equ       76                  ; ... frei
var_end   equ       80                  ; ende der kanaltabelle
max_len   equ       6                   ; ( derzeit ) grte postenlnge

* Die Offset-Vectoren der Unteraufrufe sind etwa derart zu erhalten:
*         move.l    vec_pmi(a0),a2      ; aufruf parm_in aus der kanaltabelle
*         subq.l    #4,a2               ; offset s.o. steht im speicher davor
*         add.w     (a2),a2             ; aufruf parm_it

* puffereinteilung   niedrige adr      hohe adr
* | buf_bas             | | buf_ptr|  daten            | |
* | 472 bytes locale var |   | n*6 bytes pufferbereich     |
*      6 bytes sicherheit |buf_bot             buf_top| 6 bytes sicherheit

* STKUNLK ist nicht unproblematisch und sollte sicherheitshalber
* entfernt werden, sobald der handler ganz ausgetestet ist.
* vor dem aufruf darf kein STAK-kanal mehr offen sein !

          move.w    $110,a2
          lea       basdef(pc),a1
          jsr       (a2)
          bra      startup
basdef    dc.w      5                   ; 5 proceduren
          dc.w      stkunlk-*
          dc.b      7,'STKUNLK'         ; handler aus der liste nehmen
          dc.w      st_drop-*
          dc.b      7,'ST_DROP'         ; anzahl posten weiterzhlen
          dc.w      st_swap-*
          dc.b      7,'ST_SWAP'         ; die zwei jngsten posten vertauschen
          dc.w      st_push-*
          dc.b      7,'ST_PUSH'         ; parm(-liste) ablegen
          dc.w      st_execb-*
          dc.b      8,'ST_EXECB',0      ; rechneranweisungen ausfhren
          dc.w      0,4                 ; 4 funktionen
          dc.w      st_depth-*
          dc.b      8,'ST_DEPTH',0      ; anzahl vorhandener posten
          dc.w      st_len-*
          dc.b      6,'ST_LEN',0        ; speicherkapazitt des STAK
          dc.w      st_pop-*
          dc.b      6,'ST_POP',0        ; einen posten abheben und an basic
          dc.w      st_typ-*
          dc.b      6,'ST_TYP',0        ; ablagelnge holen und ggf. setzen
          dc.w      0                   ; ende der tabelle

STKUNLK   lea       linkage(pc),a0
          tst.l     (a0)
          beq.s     stk_lret
          moveq     #33,d0              ; mt.riod
          trap      #1
stk_lret  rts

* codeliste eines bergebenen string als rechenanweisungen abarbeiten
* procedur      ST_EXECB[#kanal,]codestring      nur fr typ 6 (f.p.)
ST_EXECB  move.l    $58(a6),d6          ; bv.rip zur freigabe merken
          moveq     #2,d1               ; reserve
          move.w    $011a,a2            ; bv.chrix
          jsr       (a2)                ; reservieren
          subq.l    #2,$58(a6)          ; und fixieren
          moveq     #0,d4               ; flag zum holen eines string
          bsr       parm_tn             ; kanal und parameter
          bne.s     ste_err             ; ? bergabefehler
          lea       stemsg(pc),a2       ; botschaft
          move.l    a2,d0               ;  als
          bset      #31,d0              ;    frei definierte fehlermeldung
          tst.w     d4
          bne.s     ste_ers             ; ? nicht string
          move.w    0(a1,a6.l),d1
          ble.s     ste_ers             ; ?string ohne lnge
          lea       2(a1),a3            ; opcode-tabelle
          add.w     d1,a1
          clr.b     2(a1,a6.l)          ; abschlucode ri.term zufgen
          movem.l   buf_bot(a4),d1-d4   ; kanalvariable
          swap      d4
          subq.w    #6,d4
          bne.s     ste_ers             ; ? nicht f.p.-stack
          move.l    a4,a0               ; q.basis merken
          move.l    d1,a4               ; variablenpuffer
          move.l    d3,a1               ; laufptr
          moveq     #0,d7               ; sicherheitshalber
          move.w    $011e,a2            ; ri.execb
          move.w    sr,d5               ; aktueller status
          trap      #0                  ; supervisor
          sub.l     a6,a1               ; pointer
          sub.l     a6,a4               ;  relativ
          add.l     a6,a3               ; op-codes nicht (!) relativ
          jsr       (a2)                ; rechnen
          move.w    sr,d1               ; ergebnisflags
          add.l     a6,a1               ; pointer
          add.l     a6,a4               ; in kanal-adressierung
          move.b    d1,d5               ; aktuelle fehlerflags
          move.w    d5,sr               ; user-mode, alte interrupts
          bmi.s     ste_ers             ; ? rechenfehler
          move.l    a1,d4               ; ptr
          move.l    d2,a3               ; top
          move.l    a4,d7               ; bot
          bsr       chk_ptr             ; grenzen justieren
          move.l    buf_ptr(a0),d4
          moveq     #0,d0
ste_ers   move.l    d6,$58(a6)          ; puffer fr opcode freigeben
ste_err   rts

* eine 'freie' fehlermeldung
stemsg    dc.b      0,28,'Nur Stringparameter mglich',$a
          ds.w      0

* basic-funktion einzellnge fr einen posten lesen, ggf. neu setzen.
* statt fehlerabbruchs wirde der nagative code zurckgegeben.
ST_TYP    bsr       chan_in             ;> kanalbergabe
          bne.s     stl_rer             ; ? kanalfehler zurckgeben
          moveq     #0,d5               ; ohne parm nichts ndern
          cmp.l     a3,a5
          ble.s     stt_six
          bsr       parm_it             ; eine integer-zahl holen
stt_six   move.w    buf_fmt(a4),d6      ; aktueller typ
          tst.w     d5
          ble.s     stt_val             ; ? nur den gltigen wert holen
          btst      #0,d5
          bne.s     stt_val             ; ? ungerader wert gilt nicht
          subq.w    #6,d5
          bgt.s     stt_val             ; ? wert zu gro
          addq.w    #6,d5
          move.w    d5,buf_fmt(a4)      ; neuen typen eintragen   
stt_val   move.w    d6,d5
          bra       parm_oi             ; alten wert an basic

* basic-procedur entfernt einen oder bergebene anzahl posten vom stack.
* daten sind wiederherstellbar, solange sie nicht berschrieben wurden,
* da hiermit nur der laufpointer verstellt wird.
ST_DROP   moveq     #1,d4               ; arbeitsflag
std_ntry  bsr       chan_in             ;> kanalbergabe
          bne.s     std_ret             ; ? kanal ungltig
          move.l    d4,d5
          beq.s     std_one             ; ? fr st_depth position holen
          cmp.l     a3,a5
          ble.s     std_one
          bsr       parm_it             ; eine integer-zahl holen
std_one   moveq     #0,d1               ; fr die bergabe
          move.w    d5,d1               ; anzahl posten      
          neg.l     d1                  ; wegnehmen
          moveq     #67,d0              ; fs.posre
          bra.s     sub_trp3 

* basic-funktion liefert stacktiefe. da die nur positiv sein kann,
* wird hier statt abbruchs bei einem fehler der code zurckgegeben.
ST_DEPTH  moveq     #0,d4
          bsr.s     std_ntry            ;>kanal holen, depth ermitteln
          beq.s     stl_ret             ; ? als integer an basic
          bra.s     stl_rer             ; fehlercode zurckgeben

* basic-funktion zur angabe der gesamt verfgbaren stacktiefe
ST_LEN    moveq     #0,d4
          bsr.s     sts_ntry
stl_ret   move.l    d1,d0
stl_rer   bra       parm_rr             ; ret fehler oder lnge

* basic-procedur: die beiden jngsten posten werden ausgetauscht
ST_SWAP   moveq     #2,d4               ; flag
sts_ntry  bsr       chan_in
          bne.s     std_ret
          lea       stswap(pc),a2
          move.l    d4,d1               ; arbeitsmarke
sts_xtp   moveq     #9,d0               ; sd.extop
          bra.s     sub_trp3

* basic-procedur zum ablegen von parametern
ST_PUSH   bsr       parm_in             ; d2 len a0 id a1 quelle
          bmi.s     std_ret             ; ? kanalfehler oder keine parm
          lea       0(a1,d2.w),a4       ; ri-bereichsende zur freigabe
          moveq     #7,d0               ; io.sstrg 
          bsr.s     sub_trp4
          move.l    a4,$58(a6)          ; bergabebereich freigeben
          rts

sub_trp4  trap      #4                  ;<  a1 ist rel zu a6
sub_trp3  moveq     #127,d3             ;<  etwas warten
          trap      #3
sts_ret   tst.l     d0
std_ret   rts

* basic-funktion liefert jngsten posten
ST_POP    bsr       chan_in             ;> kanal holen
          addq.l    #1,d0               ; code anpassen
          ble.s     stp_ret             ; ? ret mit fehler
          move.w    buf_fmt(a4),a4      ; die lnge einer eintragung
          bsr.s     prm_mem             ;> speicher reservieren
          bne.s     stp_ret             ; ? ret bei err.or
          move.l    a4,d2               ; lnge
          move.l    a1,a5               ; basisptr merken
          moveq     #3,d0               ; io.fstrg
          bsr.s     sub_trp4            ; a1 ist rel a6
          bne.s     stp_xit             ; ? bertragungsfehler
          move.l    a5,a1               ; basisptr zurckstellen
          move.l    0(a1,a6.l),d5       ; lange integer
          cmp.w     #4,d1               ; typ
          beq.s     stp_put             ; ? richtig
          swap      d5                  ; sonst integer oder exponent
          move.l    2(a1,a6.l),d7       ; und ggf. mantisse
stp_put   bra.s     parm_pt             ; ? abgeben
stp_xit   move.l    a4,d1
          add.l     d1,$58(a6)          ; puffer wegnehmen
stp_ret   rts                           ; ret mit fehler

* bv.chrix aufruf mit lnge der reservierung in a4, ret mit lnge in d1
prm_mem   move.l    a4,d1               ; bytes platz machen
          move.w    $011a,a2            ; bv.chrix
          jsr       (a2)
          addq.l    #1,d0               ; minervamig ist -1 kein fehler
          bmi.s     prm_mor             ; ? err.om o.a.
          move.l    a4,d1
          sub.l     d1,$58(a6)          ; bergabebereich fixieren
          move.l    $58(a6),a1          ; offset holen
          moveq     #1,d0               ; okay
prm_mor   subq.l    #1,d0               ; code berichtigen
prm_ort   rts

* zahlen-rckgabe an basic ( parm_ou KANAL-VECTOR 64 )
* parm_pt: typ 2 bei lnge 4 als 4-byte-rckgabe mit normierung.
* kommt: d5 (lange) integer oder exponent  d7.l mantisse  a4 ret-lnge in bytes
parm_rr   move.w    d0,d5               ; fehlercode zurckgeben
parm_oi   moveq     #2,d1               ; immer integer abliefern
          move.l    d1,a4               ; lnge in bytes
          bra.s     parm_cx

          dc.w      prm_mem-*           ;vector: ri-bereich reservieren
          dc.w      parm_oi-*           ;vector: integer abliefern
parm_ou   move.w    buf_fmt(a4),a4      ;vector: zahl abliefern < posten-lnge
parm_cx   bsr.s     prm_mem             ;<> mit len in a4 ri-bereich reservieren
          move.w    d5,0(a1,a6.l)       ; integer eintragen
parm_pt   moveq     #3,d4               ;< zunchst integer-resultat
          subq.l    #2,d1
          beq.s     parm_or             ; ? integer
          subq.l    #2,d1
          bne.s     prm_fpt             ; ? f.p.-zahl abliefern
          bsr.s     lint_fp             ;> d5.l nach f.p in d5.w d7.l
prm_fpt   move.w    d5,0(a1,a6.l)
          move.l    d7,2(a1,a6.l)
          and.w     #$0fff,0(a1,a6.l)   ; sicherheitshalber gltiger exponent
          moveq     #2,d4               ; f.p.-resultat
parm_or   moveq     #0,d0               ; ohne fehler
          rts

* d5.l lange integer als f.p.-zahl normiert an basic zurckgeben
lint_fp   move.l    d5,d7               ; lange integer
          beq.s     lint_xit            ; ? null ist damit erledigt
          moveq     #2,d1               ; 2 bytes
          move.l    d1,a4               ;  fehlen noch
          bsr.s     prm_mem             ;> bytes fixieren
          move.l    d5,d3               ; zum rechnen
lint_pos  move.w    #$081F,d5           ; anfangs d3 ohne gebrochenen anteil
          add.l     d3,d3               ; Cy bit 31, V-flag bit 31 xor bit 30
          bvs.s     lint_sgn            ; ? fertig bei vorzeichenwechsel
          subq.w    #1,d5               ; exp an multiplikation anpassen
          move.l    d3,d7               ; mit 2facher mnt weiterrechnen
          moveq     #16,d0              ; anfangswert entspr. 2^16
lint_nrm  move.l    d7,d3               ; mantisse zur probe
          asl.l     d0,d3               ; multiplikation 2^(d0)
          bvs.s     lint_nxt            ; ? irgendwo ein vorzeichenwechsel
          sub.w     d0,d5               ; sonst division im exponenten
          move.l    d3,d7               ; und bernahme der mantisse
lint_nxt  asr.w     #1,d0               ; nchster zhler mit halbem wert
          bne.s     lint_nrm            ; ? solange noch zu zhlen ist
          bra.s     lint_xit            ; normierung fertig
lint_sgn  bcc.s     lint_xit            ; ? 2^30-1 < zahl < 2^31
          addq.w    #1,d5               ; exp * 2
          lsr.l     #1,d7               ; in mnt mit / 2 ausgleichen
lint_xit  rts                           ; d1 flag 0 int =/=0 fp  d5 exp d7 mnt

* mit vorgabe in d5 eine integer-zahl holen, pat a3 entsprechend an
* ndert: d0 d3 ( d5 ) a1 a3    konserviert: d1 d2 d4 d6 d7 a0 a2 a4
parm_it   moveq     #0,d0               ; ohne parm ist kein fehler
          cmp.l     a3,a5
          ble.s     parm_ir             ; ? nichts holen
          movem.l   d1-d2/d4/d6-d7/a0/a2/a4-a5,-(sp)
          lea       8(a3),a5            ; einen parm eingrenzen
          move.w    $0112,a2            ; ca.gtint
          jsr       (a2)
          move.l    a5,a3               ; stets die neue untergrenze
          movem.l   (sp)+,d1-d2/d4/d6-d7/a0/a2/a4-a5
          bne.s     parm_ir             ; ? fehler im parm
          subq.w    #1,d3               ; ein parm
          bne.s     parm_ir             ; ? nicht angekommen
          move.w    0(a1,a6.l),d5       ; vorgabe berschreiben
          addq.l    #2,$58(a6)          ; in bv.rip bereich freigeben
parm_ir   tst.l     d0
          rts

parmvec   dc.w      $0116,$0112,$0118   ; ca.gtstr ca.gtint ca.gtlin
parmtab   dc.w      $0114               ; ca.gtfp
parmtyp   dc.b      -1,0,2,6,-1,-1,-1,-1,-1,-1
parmerr   dc.w      22,'Falscher Parametertyp',$0a00

* alle basic-parameter im selbem typen holen ( KANAL-VECTOR 60 parm_vi )
* kommt: a3 a5 a6 basic-register       erhlt: a0 a2 (a3) a5 a6  d1 d6 d7
* geht : d0 fehler d2 bergabelnge d3 anzahl posten d4 parm-typ d5 postengre
*        a0 kanal-id  a1 parmpuffer  a3 name-table angepat  a4 q.kanal-basis
          dc.w      parm_it-*
          dc.w      parm_vi-*
parm_in   moveq     #-1,d4              ; flag fr typentsprechende parm
parm_tn   bsr.s     chan_in             ;> kanalangabe
          bne.s     parm_rt
* zum einsprung mu vorliegen: d2 null a0 kanal-id  a4 q.kanalbasis
parm_vi   moveq     #-17,d0             ; err.xp
          cmp.l     a3,a5
          ble.s     parm_rt             ; ? wenn keine parm da sind
          move.w    buf_fmt(a4),d5      ; byte-format fr einen datenposten
          ble.s     parm_rt             ; ? freies format ist hier ungltig
          btst      #0,d5
          bne.s     parm_rt             ; ? ungerade geht auch nicht
          move.w    d5,d2               ; zum rechnen fr tabellenplatz
          tst.l     d4                  ; typen-flag
          bmi.s     parm_tp             ; ? entsprechend dem stack-typen
          moveq     #15,d5              ; zur kontrolle
          and.b     1(a3,a6.l),d5       ; wirklicher parmtyp
          move.b    parmtyp(pc,d5.w),d5 ; als stack-typ
          move.w    d4,d2               ; typ der anforderung
parm_tp   move.w    d2,d4               ; parm-typ merken
          subq.w    #max_len,d2         ; grter zulssiger wert
          bgt.s     parm_rt             ; ? wurde berschritten
          movem.l   d1/d4/d6/a0/a2,-(sp) ; register kellern
          pea       parmerr(pc)         ; text
          bset      #7,(sp)             ; gilt als fehlermeldung
          cmp.b     d4,d5               ; geforderter und wirklicher typ
          bne.s     parm_nt             ; ? nicht der richtige typ
          move.w    parmtab(pc,d2.w),a2 ; offset zu den vectoren
          move.w    (a2),a2             ;  passend zur byte-anzahl
          jsr       (a2)                ; parm dem typen gem holen
parm_nt   movem.l   (sp)+,d0-d1/d4/d6/a0/a2
          bne.s     parm_rt             ; ? fehler in der bergabe
          moveq     #0,d0
          move.w    d5,d2               ; aus byte-format
          mulu      d3,d2               ; gesamtanzahl bergebener bytes
parm_rt   tst.l     d0
          rts

* basic-kanal holen  ( KANAL-VECTOR 56 )
* kommt: a3 a5 a6 basic-register       erhlt: d4 d7 a2     
* geht : d0 fehler a0 kanal-id a3 angepat a4 q.kanal-basis a5 unverndert
          dc.w      chan_ck-*           ; aufruf-ptr prfung d6 als kanal-id
          dc.w      chan_id-*           ; aufruf-ptr bei kanalnummer in d5
chan_in   moveq     #4,d5               ;vector: kanal holen  vorgabekanal
          moveq     #0,d0               ; erstmal okay
          cmp.l     a3,a5
          ble.s     chan_id             ; kein parm angegeben
          tst.b     1(a3,a6.l)          ; negativ bei '#'
          bpl.s     chan_id             ; ? ohne hash gilt vorgabe
          bsr       parm_it             ;> eine integer holen
chan_id   moveq     #-7,d0              ; err.nf zuerst
          mulu      #40,d5              ; tabellenoffset in die basic-kanle
          add.l     48(a6),d5           ; bv.chbas tabellenbasis
          cmp.l     52(a6),d5           ; bv.chp obergrenze der tabelle
          bhi.s     chan_rt             ; ? kanal existiert nicht
          moveq     #-6,d0              ; err.no
          move.l    0(a6,d5.l),d6       ; soll id sein
chan_ck   bmi.s     chan_rt             ; ? kanal ist zu
          moveq     #0,d0               ; mt.inf
          trap      #1                  ; a0 basis der systemvariablen
          move.l    120(a0),a4          ; qdos-kanaltabelle
          move.l    d6,a0               ; kanal-id
          lsl.w     #2,d6               ; tabellenoffset aus qdos-kanalnummer
          move.l    0(a4,d6.w),a4       ; kanal-definitionsblock
          moveq     #-2,d0              ; err.nj bei falschem kanaltypen
          lea       linkage(pc),a1      ; STAK-handler
          cmp.l     4(a4),a1            ; handler des kanals
          bne.s     chan_rt             ; ? ungeeigneter kanal
          moveq     #-9,d0              ; err.iu
          swap      d6                  ; tag ( lfd.nr. der kanalzuweisung )
          cmp.w     16(a4),d6
          bne.s     chan_rt             ; ? kanal anderweitig definiert
          moveq     #0,d0               ; nun ist alles in ordnung
chan_rt   moveq     #0,d2               ; bergabeflag vorbereiten
          tst.w     d0
          rts

* aufbau der definitionsblcke und einfgung in die liste der einfachen
* devices. dieser bereich des speichers ist danach frei verwendbar.
startup   lea       4+clo_ptr(PC),a0      ; aufruf-liste
          lea       clse_cde(PC),a1     ; trap #2 close
          move.l    a1,-(a0)
          lea       open_cde(PC),a1     ; trap #2 open
          move.l    a1,-(a0)
          lea       io_cde(PC),a1       ; trap #3 i/o
          move.l    a1,-(a0)            
          subq.l    #4,a0               ; linkadresse
          moveq     #32,d0              ; mt_liod
          trap      #1                  ; device handler anmelden
          rts

* extop-aufruf
* d1=0 zum vertauschen zweier posten im stack
* d1=1 ri.execb ausfhren
* d1=2 stacklnge zurckgeben
stswap    moveq     #-13,d0             ; err.te fr falsche bergabe
          move.w    d5,d2               ; einfache lnge
          ble.s     sts_srt             ; ? null oder viel zu gro
          subq.l    #max_len,d5
          bgt.s     sts_srt             ; ? immernoch zu gro
          addq.l    #max_len,d5
          add.l     d5,d4
          move.l    d4,a2               ; ptr auf den zweiten posten
          add.l     d5,d4    
          subq.l    #1,d1
          bmi.s     stslen              ; ? aufruf st_len
          bsr       chk_ptr             ;> zielptr prfen 
          blt.s     sts_srt             ; ? nicht zwei posten vorhanden
          move.l    a4,a3               ; aktueller laufptr
          subq.w    #1,d2               ; zhler
sts_swp   move.b    (a3),d4
          move.b    (a2),(a3)+
          move.b    d4,(a2)+
          dbra      d2,sts_swp          ; byteweise tauschen
sts_kay   moveq     #0,d0               ;< okay
sts_srt   rts
* ret max anzahl posten 
stslen    move.l    a3,d1
          sub.l     d7,d1
          divu      d5,d1               ; len
          ext.l     d1
          bra.s     sts_kay

* aufruf d0.b trapnummer  d1 d2  datenbergabe  d3 ggf. wartezeit
*        a0 kanalbasis    a1 a2 datenbergabe   a6 sysvars  a7 ssp
* mit dem einsprung werden belegt
*        d4 buf_ptr d5 buf_fmt d7 buf_bot a3 buf_top a4 buf_ptr a5 buf_fmt.l
* rckgabe ggf. in d1 a1, ungerade adressen verursachen keinen fehler
* vom aufruf her bleiben unverndert d4 - d7 und a0, a2 - a7
* gltige codes und zugehrige ausfhrung sind
*   0   io.pend    depth prfen  err.ef stk leer 
*   3   io.fstrg   pop bytes     err.ef           err.te falsches format
*   7   io.sstrg   push bytes    err.df stk voll  err.te
*   9   sd.extop   handlererweiterung     fehler von dorther
* $42   fs.posab   tos setzen nach anzahl posten
* $43   fs.posre   tos verschieben. beide err.ef und err.df

* die adressen der einzelnen routinen sind hier verzeichnet, der datenblock
* kann an beliebiger stelle stehen und ist fr rom-tauglichkeit auszulagern.
linkage   dc.l      0                   ; link zum nchsten device-handler
io_ptr    dc.l      0                   ;  I/O code   - trap #3
opn_ptr   dc.l      0                   ;  open code  - trap #2
clo_ptr   dc.l      0                   ;  close code - trap #2

* trap #3 i/o-einsprung
io_cde    movem.l   buf_bot(a0),d7/a3-a5  ; buf_bot / _top / _ptr / _fmt
          move.l    a4,d4               ; arbeitscopie des laufptr
          move.l    a5,d5
          clr.w     d5
          swap      d5                  ; datenformat
          ext.w     d0
          dbra      d0,io_ftch          ; ( 3 7 9 66 67 )
* io.pend: ret err.ef leer err.df voll  a1 rest bytes  d1 depth
          bsr       chk_ptr
          bne.s     iop_xit
          moveq     #0,d1               ; leere rckgabe
          move.l    d1,a1               ;   vorbereiten
          sub.l     a3,d4               ; ptr - top 
          beq.s     iop_xit
          neg.l     d4                  ; vorhandene bytes
          divu      d5,d4               ; aktuelle posten-lnge
          move.w    d4,d1               ; depth abliefern
          swap      d4                  ; verbliebene bytes
          move.w    d4,a1               ; abliefern
iop_xit   moveq     #0,d0
iop_ret   rts

* bytes holen, d2 pufferlnge  a1 pufferbasis
* nur bei erfolgreicher operation a1 angepat, d1 besetzt
io_ftch   subq.w    #5,d0
          dble      d0,io_send
          addq.w    #3,d0
          bne.s     err_bp              ; ? ( 1 2 4 5 6 ) ungltig
          moveq     #0,d1               ; fr leere rckgabe
          moveq     #0,d6               ; vorzeichenlose
          move.w    d2,d6               ;   lnge
          bmi.s     err_or              ; ? mit err.or bei 32K oder mehr
          beq.s     iop_xit             ; ? leere anforderung ohne fehler
          moveq     #0,d0               ; zunchst okay
          sub.l     d4,a3               ; top - ptr =: depth in bytes
          cmp.l     d6,a3               ; mit geforderter anzahl vergleichen
          bpl.s     io_flen             ; ? gengend daten vorhanden
          moveq     #-10,d0             ; sonst jedenfalls err.ef
          move.l    a3,d6               ;  und gesamten inhalt holen
io_flen   move.w    d6,d1               ; rckgabe vorbereiten
          ble.s     err_ef              ; ? err.ef 32K oder mehr oder nichts
          move.w    d6,d2               ; justierte lnge
          bsr       len_ntry            ;> mu zum format (d5) passen
          bmi.s     iop_ret             ; ? falsches format
          move.w    d1,d2               ; lnge
          subq.w    #1,d2               ;  als zhler
io_insts  move.b    (a4)+,(a1)+         ; alles byteweise holen
          dbra      d2,io_insts
          move.l    a4,buf_ptr(a0)
          rts                           ; ret daten, ptr, fehler

* fehlercode und flags zurckgeben
err_ef    moveq     #-10,d0
          rts
err_bp    moveq     #-15,d0              
ret_io    rts
len_rret  moveq     #0,d5               ; len reicht nicht fr einen posten
err_or    moveq     #-4,d0
          rts
err_te    moveq     #-13,d0
          rts

* io.sstrg mit d2 anzahl bytes a1 puffer, geht angepat mit d1 zurck
* err.df, wenn der platz nicht fr smtliche daten ausreicht
io_send   subq.w    #1,d0               ; ( 78 )
          dble      d0,io_xtop          ; ( 9 66 67 )
          beq.s     err_bp              ; ( 8 ) ungltig 
          bsr.s     len_ntry            ;> lnge im format (d5) kontrollieren
          bmi.s     ret_io              ; ? leer oder nicht passend
          move.l    a4,d4               : laufptr
          sub.l     d1,d4               ; niedrigste zieladresse
          bsr       chk_ptr             ;> grenzen prfen
          bgt.s     ret_io              ; ? berlauf 
          move.l    d4,a2               ; copie zum transport
          move.w    d1,d2               ; lnge
          subq.w    #1,d2               ;  als zhler
io_puts   move.b    (a1)+,(a2)+         ; alle bytes
          dbra      d2,io_puts          ;  senden
out_ptr   moveq     #0,d0               ; ohne fehler
          move.l    d4,buf_ptr(a0)      ; laufptr sichern
          rts

* extop-aufruf
io_xtop   dbra      d0,io_cpos          ; ( 66 67 )
          pea       (a2)                ; abeitsadresse ablegen
          lea       vec_len(a0),a2      ; basis fr 1. vector angeben
          rts                           ; sd.extop ausfhren

* pos-traps setzen den stackpointer mit grenzwerten bei berlauf
io_cpos   sub.b     #$38,d0             ; fs.posab
          blt.s     err_bp              ; ? ungltiger code
          muls      d5,d1               ; bytes d1 := d1 * format
          subq.b    #1,d0               ; fs.posre
          bgt.s     err_bp              ; ? rest ist ungltig
          beq.s     io_prel             ; ? position weiterzhlen
* fs.posab: position zhlt ab obergrenze mit null beginnend
          move.l    a3,a4               ; obergrenze
io_prel   sub.l     d1,a4               ;<relative / neue position
* grenzen prfen, position aus d1 eintragen und abliefern
          bsr.s     ofs_ntry            ;> justierte position
          move.l    d5,d4
          bsr.s     chk_ptr             ;> ptr prfen
* rckgabe ohne fehler mit laufptr in kanaltabelle & ggf. in a1 
          moveq     #0,d1
          move.w    d6,d1               ; depth bergeben
          move.l    d4,a1               ; laufptr bergeben
          bra.s     out_ptr             ; ret daten & ptr ohne fehler

* lnge d2.w zur prfung auf einhalten der posten-grenzen
* ERSTER VECTOR DER KANALTABELLE  ( 44 )  - LEN_CHK -
* rein                        raus
*                             d0      unverndert bei passender lnge/err.te
*                             d1.l    justierte lnge
* d2.w   geforderte lnge     d2.l    anzahl posten
*                             d3      unverndert
*                             d4.w.w  bytelen.hi & bytecount.lo je posten
* d5.w   byteformat ( _ntry ) d5      doppelte bytes als sprungweite im stack
*                             d6.l    rest bytes
* 
len_chk   move.w    buf_fmt(a0),d5      ; multiplikator zugleich mindestlnge
len_ntry  moveq     #0,d6               ;
          moveq     #0,d4
          move.w    d5,d4               ; bytes je posten
          swap      d4                  ; nach hi.w
          move.w    d2,d6               ; lnge vorzeichenlos langmachen
          cmp.w     d5,d6
          blt.s     len_rret            ; ? zu wenig bytes oder ab 32K * (d5) 
          divu      d5,d6
          move.w    d6,d4               ; anzahl posten ( mindestens 1 )
          mulu      d4,d5               ; anzahl bytes
          clr.w     d6
          swap      d6                  ; rest einzelne bytes
          bne.s     err_te              ; ? falsches format
          move.l    d5,d1               ; richtige lnge zurckgeben
          move.l    d6,d5               ; byteanzahl 
          add.w     d5,d5               ;  fr sprungweite 
          subq.w    #1,d4               ; zhler fr bytes je posten
          clr.w     d4
          swap      d4                  ; anzahl posten
          subq.w    #1,d4               ;  als zhler
          move.l    d4,d2               ; flags 'pl'
          rts                           
                             
* d5 auf die ohne rest durch buf_fmt(a0) teilbare kleinste
* zahl justiert, die grer oder gleich dem laufptr ist.           
* DRITTER VECTOR DER KANALTABELLE ( 52 )  - OFS_PTR -     
* rein                        raus
* d5.w  byteformat ( _ntry )  d5.l   justierter laufptr
*                             d6.w.w hi rest bytes  lo depth.w ( postenanzahl )
* a3    obere bereichsgrenze
* a4    laufpointer
ofs_ptr   move.w    buf_fmt(a0),d5      ; multiplikator
ofs_ntry  move.l    a3,d6               ; obergrenze
          sub.l     a4,d6               ; laufptr    
          divs      d5,d6               ; d6.hi.w rest bytes  d6.lo.w depth
          muls      d6,d5               ; anzahl f.p.-posten nach bytes
          neg.l     d5                  ; ist abstand von oben her
          add.l     a3,d5               ; top dazu fr den f.p.-ptr        
          rts                                                             

* d4 hat angepaten stackptr, fehler in d0 & flags  verndert: a5
* ret d0 fehlercode flags: berlauf 'gt', leer 'lt', innerhalb 'eq' 
* ZWEITER VECTOR DER KANALTABELLE ( 48 )  - CHK_PTR -
* rein                        raus
*                             d0   okay 'eq' / err.ef 'lt' oder err.df 'gt'
* d4   laufptr                d4             / auf grenze justiert
* d7   untere bereichsgrenze
* a3   obere dto.
*                             a5   verdorben
chk_ptr   moveq     #-10,d0             ; err.ef
          move.l    d4,a5               ; bergabe merken
          move.l    a3,d4               ; top
          cmp.l     a5,d4               ; - "stack leer" -  
          blt.s     chk_xit             ; ? berschritten
          subq.w    #1,d0               ; err.df
          move.l    d7,d4               ; bot
          cmp.l     a5,d4               ; - "berlauf" -
          bgt.s     chk_xit             ; ? berschritten
          move.l    a5,d4               ; bergabe war gltig
          moveq     #0,d0               : err.ok
chk_xit   rts                        

* io.open ( 2 / 1 )
open_cde  subq.l    #2,a7               ; t.o.s.
          move.l    a7,a3               ; a3 => parm
          move.w    $0122,a2            ; io_name
          jsr       (a2)
          bra.s     xit_opn             ; name fehlerhaft
          bra.s     xit_opn             ; parameter dto.
          bra.s     open_ok             ; name ok, {a3}+.w: gre 
          dc.w      4,'STAK'            ;   a0:=q.kanal-basis
          dc.w      1                   ; max 1 parm
          dc.w      ' _',320            ; '_' & vorgabeanzahl posten 
open_ok   move.l    a3,a5               ; a5 => parm
          moveq     #var_end,d1         ; gre des kanal-definitionsblocks
          move.w    $c0,a2              ; mm.alchp
          jsr       (a2)
          bne.s     xit_opn             ; ? heap nicht reservierbar
          moveq     #4,d7               ; minimum
          cmp.w     (a5),d7
          bgt.s     no_size             ; ohne oder zuviele posten
          moveq     #80,d0              ; 78+2 f.p.-posten arbeitsbereich
          move.w    (sp),d7
          add.l     d7,d0               ; 80 + bergabe
          move.l    d0,d7               ; copie
          add.l     d7,d7               ; * 2
          add.l     d0,d7               ; * 3
          add.l     d7,d7               ; 6-fache anzahl bytes
          move.l    a0,a4               ; kanal-basis merken
          move.l    d7,d1               ; pufferlnge angegeben
          moveq     #-1,d2              ; aktueller job ist besitzer
          moveq     #$18,d0             ; mt_alchp
          trap      #1                  ; pufferspeicher reservieren
          tst.l     d0
          bne.s     no_room             ; ? platz unzureichend
          lea       474(a0),a1          ; bereichs-untergrenze - sicherheit
          lea       -6(a0,d7.l),a2      ; obergrenze + sicherheit
          move.l    a2,a3               ; laufptr
          movem.l   a0-a3,buf_bas(a4)
          move.l    a4,a0               ; def.block bereitlegen
          moveq     #6,d7               ; vorgegeben 
          swap      d7                  ; f.p.format | null
          lea       len_chk(pc),a1      ; vector prfung der lngenangabe
          lea       chk_ptr(pc),a2      ; vector grenzen f. laufptr prfen
          lea       ofs_ptr(pc),a3      ; vector laufptr dem format anpassen
          lea       chan_in(pc),a4      ; vector basic-kanal holen
          lea       parm_in(pc),a5
          lea       parm_ou(pc),a6      ; ( sysvars nicht mehr ntig )
          movem.l   d7/a1-a6,buf_fmt(a0) ; in den def-block
xit_opn   tst.l     d0                  ; flags aktualisieren
xit_drp   addq.l    #2,sp               ; drop bergabeparameter
          rts

* fehler beim ffnen
chn_rmv   move.l    a4,a0               ; kanalblock zurechtlegen
chn_drp   move.l    d0,-(sp)            ; fehler kellern
          bsr.s     chn_remv            ; kanaltabelle auflsen
          move.l    (sp)+,d0            ; fehlercode
          bra.s     xit_drp             ; drop parm und zurck
no_room   moveq     #-3,d0              ; err.om speicher reicht nicht
          bra.s     chn_rmv             ; kanalblock in A4
no_size   moveq     #-15,d0             ; err.bp grenangabe fehlt
          bra.s     chn_drp

* io.close ( 2 / 2 )
clse_cde  move.l    a0,a4               ; defblock merken
          move.l    24(a4),a0           ; pufferbasis
          moveq     #$19,d0             ; mt_rechp
          trap      #$01                ; puffer auflsen
          move.l    a4,a0               ; kanalbasis zurck
chn_remv  move.w    $c2,a2              ; mm_rechp
          jmp       (a2)                ; kanal abtrennen

          end



